#include <stdio.h>
#include <string.h>
#include <unistd.h>

int month[20];
int mask[300];
char mask_str[30];
char dates[10000];
char leap;
int y, golden, solar, lunar, p;

int holiday[20];

int start_day[4000];

int main() {
	start_day[2010] = 4;
	for (y = 2010; y <= 3000; y++) {
		leap = (y % 4 == 0) && ((y % 100) != 0 || (y % 400) == 0);
		start_day[y+1] = (start_day[y] + 365 + leap) % 7;
	}
	for (y = 2009; y; y--) {
		leap = (y % 4 == 0) && ((y % 100) != 0 || (y % 400) == 0);
		start_day[y] = (start_day[y+1] + 700 - 365 - leap) % 7;
	}

	while (scanf("%s %s %d", mask_str, dates, &y) == 3) {
		int result = 0;
		leap = (y % 4 == 0) && ((y % 100) != 0 || (y % 400) == 0);
		int sd = start_day[y];

		memset(mask, 0, sizeof(mask));
		for (int i = 0; mask_str[i]; i++)
			mask[mask_str[i]] = 1;
		if (mask['t']) mask['7'] = 1;

		month[2] = 31;
		month[3] = month[2] + 28 + leap;
		month[4] = month[3] + 31;
		month[5] = month[4] + 30;
		month[6] = month[5] + 31;
		month[7] = month[6] + 30;
		month[8] = month[7] + 31;
		month[9] = month[8] + 31;
		month[10] = month[9] + 30;
		month[11] = month[10] + 31;
		month[12] = month[11] + 30;

		golden = (y % 19) + 1;
		solar = (y - 1600) / 100 - (y - 1600) / 400;
		lunar = (((y - 1400) / 100) * 8) / 25;
		p = (3003 - (11 * golden) + solar - lunar) % 30;
		if (p == 29 || ( p == 28 && golden > 11)) p--;
		int pfm = month[3] + 20 + p;

		holiday[0] = 0;
		holiday[1] = month[3];
		holiday[2] = month[3] + 7;
		holiday[3] = month[7] + 4;
		holiday[4] = month[7] + 5;
		holiday[5] = month[9] + 27;
		holiday[6] = month[10] + 27;
		holiday[7] = month[11] + 16;
		holiday[8] = month[12] + 23;
		holiday[9] = month[12] + 24;
		holiday[10] = month[12] + 25;
		holiday[11] = ((pfm+1-sd) / 7) * 7 + 7;

		int m, d, start, end;
		printf("<%s>\n", dates);
		for (int i = 0; dates[i]; i++) {
			i+= dates[i] == ',';
			m = d = 0;
			for (; dates[i] != '.'; i++)
				d = d*10 + dates[i]-'0';
			for (i++; dates[i] != '.'; i++)
				m = m*10 + dates[i]-'0';
			start = month[m] + d - 1;
			if (m == 2 && d == 29) start--;

			if (dates[++i] == '-') {
				d = m = 0;
				for (i++; dates[i] != '.'; i++)
					d = d*10 + dates[i]-'0';
				for (i++; dates[i] != '.'; i++)
					m = m*10 + dates[i]-'0';
				end = month[m] + d - 1;
				if (m == 2 && d == 29) end--;
			} else end = start;

			int c;
#define DAYS(x) c = (x)-(start+sd)%7, (end - start + 7 - c) / 7
			for (int x = 0; x < 7; x++) {
				if (!mask[x+'1']) continue;
				result += DAYS(x);
			}

			if (mask['t']) {
				for (int h = 0; h < 12; h++) {
					if (start > holiday[h] || end < holiday[h])
						continue;
					if (!mask[(holiday[h]+sd)%7 + '0'])
						result++;
				}
			}

			if (mask['w']) {
				for (int w = 0; w < 5; w++) {
					if (mask[w+'0']) continue;
					result += DAYS(w);
					for (int h = 0; h < 12; h++) {
						if (start > holiday[h] || end < holiday[h])
							continue;
						result--;
					}
				}
			}
			
			if (mask['a']) {
				for (int h = 0; h < 12; h++) {
					if ((holiday[h] + 1 + sd) % 7 == 6) continue;
					if (holiday[h]+1 == holiday[h+1]) continue;
					if (mask[(holiday[h]+8-sd)%7 + '0']) continue;
					result++;
				}

				result += DAYS(6);
				for (int h = 0; h < 12; h++) {

				}
			}
		}

		printf("%d\n", result);
	}
	return 0;
}
