#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

#define MAX 151000

#define TR int*

typedef vector<int> VI;
typedef int I;

int nearest2mul(int x)
{
	int j = 1;
	while(j < x) j *= 2;
	return j;
}

void clearT(TR strom, int intLen)
{
	int len2 = nearest2mul(intLen);

	for(int i = 0; i < len2; i++)
			strom[i] = 0;
}

void addT(TR strom, int intLen, int pos)
{
	int len2 = nearest2mul(intLen);
	int l = 0, r = len2 - 1;
	int p = 0;
	strom[p]++;
	while(r - l > 0)
	{
		int m = (r + l) / 2;
		if(pos > m)
		{
			p = 2*p + 2;
			l = m + 1;
		} else {
			r = m;
			p = 2*p + 1;
		}
		strom[p]++;
		//printf("%d %d %d %d\n", l,r,p,pos);
	}
}

void removeT(TR strom, int intLen, int pos)
{
	int len2 = nearest2mul(intLen);
	int l = 0, r = len2 - 1;
	int p = 0;
	strom[p]--;
	while(r - l > 0)
	{
		int m = (r + l) / 2;
		if(pos > m)
		{
			p = 2*p + 2;
			l = m + 1;
		} else {
			r = m;
			p = 2*p + 1;
		}
		strom[p]--;
	}
}

int countT(TR strom, int intLen, int frompos)
{
		int len2 = nearest2mul(intLen);
		int l = 0, r = len2 - 1;
		int p = 0;
		int result = 0;
		while(r - l > 0)
		{			
			int m = (r + l) / 2;
			if(frompos == l)
			{
				result += strom[p];
				break;
			}
			if(frompos > m)
			{
				p = 2*p + 2;																	l = m + 1;
																							} else {
				result += strom[2*p + 2];
				r = m;				
				p = 2*p + 1;																							}
		}
		return result;
}


/*
int main(){

	int s[MAX];
	clearT(s, 7);
    addT(s, 7, 1);    addT(s, 7, 3);    addT(s, 7, 6);	addT(s, 7, 4);
	addT(s, 7, 4);
    printf("%d\n", countT(s, 7, 2));
	removeT(s, 7, 4);
    printf("%d\n", countT(s, 7, 2));

	return 0;

}
*/

int strom1[3*MAX];
int strom2[3*MAX];

I n;
I por[MAX];

unsigned long long int sum = 0;

VI merge(VI a, VI b)
{
	int i;

	VI res;
	for(i=0;i<a.size();i++)
	{
		addT(strom1, n+3, n+1 -a[i]);
	}

	for(i=0;i<b.size();i++)
	{
		addT(strom2, n+3, n+1 -b[i]);
	}

	I ak = 0, bk = 0;

	while(ak < a.size() && bk < b.size())
	{
		if( por[ a[ak] ] > por[ b[bk]])
		{
			res.push_back(a[ak]);
			removeT(strom1, n+3, n+1 -a[ak]);
			//sum += countT(strom2, n+3, a[ak]);
			ak++;
		} else 
		{
			res.push_back(b[bk]);
			removeT(strom2, n+3, n+1 -b[bk]);
			sum += countT(strom1, n+3, n+1 -b[bk]);
			bk++;
		}
	}

	while(ak < a.size())
	{
		removeT(strom1, n+3, a[ak]);
		res.push_back(a[ak]);
		ak++;
	}

	while(bk < b.size())
	{
		removeT(strom2, n+3, b[bk]);
		res.push_back(b[bk]);
		bk++;
	}

	return res;
}

VI mergesort(VI a)
{
	I i;

	if(a.size() <= 1)
		return a;

	VI a1, a2;

	for(i=0;i<a.size()/2;i++)
	{
		a1.push_back(a[i]);
	}

	for(i=a.size()/2;i<a.size();i++)
	{
		a2.push_back(a[i]);
	}
	VI a11;
	VI a12;

	a11 = mergesort(a1);
	a12 = mergesort(a2);

	return merge(a11,a12);
}

int main()
{
	I pb[MAX];
	I pa[MAX];
	I r[MAX];
	I c,i;
	VI pb2;

	scanf("%d\n",&n);
	while(n)
	{
		pb2.clear();
		sum = 0;
		for(i=0;i<n;i++)
		{
			scanf(" %d",&c);
			r[c-1] = i;
		}

		for(i=0;i<n;i++)
		{
			scanf(" %d", &c);
			pa[i] = r[c-1];
			por[pa[i]] = i;
		}

		for(i=0;i<n;i++)
		{
			scanf(" %d", &c);
			pb[i] = r[c-1];
			pb2.push_back(r[c-1]);
			printf("pridavam b%d=%d\n", i, r[c-1]);
		}

		mergesort(pb2);
		printf("%llu\n", sum);
		scanf("%d\n",&n);
	}
}
